#Template(QLocator,'Queue Incremental Locator V1.0b'),Family('cw20'),Family('ABC')
#EXTENSION(QLocator, 'Queue Locator'), DESCRIPTION('Queue Locator on ' & %ListBoxUseVariable), PROCEDURE,MULTI,LAST
#!--------------------------------------------------
#! Define Incremental Queue Locator
#! This template was developed by Andrew van Rooyen
#! All rights reserved
#! Copyright 2001 By Andrew van Rooyen
#!--------------------------------------------------
#!
#SHEET
#TAB('Queue Incremental Locator V1.0b')
#!DISPLAY('')
#DISPLAY('(C) 2001 by Andrew van Rooyen')
#DISPLAY('email: andyvr@mweb.co.za')
#DISPLAY('')
#DISPLAY('The queue must be sorted on the Queue Sort Field')
#DISPLAY('selected below, or this template will not work!')
#DISPLAY('The locator is case sensitive unfortunetly therefore I')
#DISPLAY('advise the use of a sort field specificly designed as')
#DISPLAY('the locator. ')
#DISPLAY('When adding data to the Queue, use')
#DISPLAY('Q.Sortfield = UPPER(Data).')
#DISPLAY('')
#DISPLAY('I accept no responsibility in the use of this template.')
#DISPLAY('Use at your own risk!')
#DISPLAY('')
#!
#!
#PROMPT ('List Box Use Variable: ',Control),%ListBoxUseVariable,REQ,AT(90)
#!DISPLAY('')
#PROMPT ('Queue: ',Field),%QueueName,REQ,AT(90)
#!DISPLAY('')
#PROMPT ('Queue Sort Field: ',Field),%QueueSortField,REQ,AT(90)
#!DISPLAY('')
#DISPLAY('Sort Queue?')
#PROMPT ('',CHECK),%ShouldISortTheQueue,AT(90,195)
#ENDTAB
#ENDSHEET
#!
#!
#!
#AT (%DataSectionBeforeWindow)
AVR:QLocator  STRING(255)
AVR:Position  LONG
#ENDAT
#AT (%AfterWindowOpening)
%Window{PROP:Alrt,255} = AKey
%Window{PROP:Alrt,255} = BKey
%Window{PROP:Alrt,255} = CKey
%Window{PROP:Alrt,255} = DKey
%Window{PROP:Alrt,255} = RKey
%Window{PROP:Alrt,255} = FKey
%Window{PROP:Alrt,255} = GKey
%Window{PROP:Alrt,255} = HKey
%Window{PROP:Alrt,255} = IKey
%Window{PROP:Alrt,255} = JKey
%Window{PROP:Alrt,255} = KKey
%Window{PROP:Alrt,255} = LKey
%Window{PROP:Alrt,255} = MKey
%Window{PROP:Alrt,255} = NKey
%Window{PROP:Alrt,255} = OKey
%Window{PROP:Alrt,255} = PKey
%Window{PROP:Alrt,255} = QKey
%Window{PROP:Alrt,255} = RKey
%Window{PROP:Alrt,255} = SKey
%Window{PROP:Alrt,255} = TKey
%Window{PROP:Alrt,255} = UKey
%Window{PROP:Alrt,255} = VKey
%Window{PROP:Alrt,255} = WKey
%Window{PROP:Alrt,255} = XKey
%Window{PROP:Alrt,255} = YKey
%Window{PROP:Alrt,255} = ZKey
%Window{PROP:Alrt,255} = Key0
%Window{PROP:Alrt,255} = Key1
%Window{PROP:Alrt,255} = Key2
%Window{PROP:Alrt,255} = Key3
%Window{PROP:Alrt,255} = Key4
%Window{PROP:Alrt,255} = Key5
%Window{PROP:Alrt,255} = Key6
%Window{PROP:Alrt,255} = Key7
%Window{PROP:Alrt,255} = Key8
%Window{PROP:Alrt,255} = Key9
%Window{PROP:Alrt,255} = KeyPad1
%Window{PROP:Alrt,255} = KeyPad2
%Window{PROP:Alrt,255} = KeyPad3
%Window{PROP:Alrt,255} = KeyPad4
%Window{PROP:Alrt,255} = KeyPad5
%Window{PROP:Alrt,255} = KeyPad6
%Window{PROP:Alrt,255} = KeyPad7
%Window{PROP:Alrt,255} = KeyPad8
%Window{PROP:Alrt,255} = KeyPad9
%Window{PROP:Alrt,255} = KeyPad0
%Window{PROP:Alrt,255} = HomeKey
%Window{PROP:Alrt,255} = MouseLeft
%Window{PROP:Alrt,255} = MouseRight
%Window{PROP:Alrt,255} = DownKey
%Window{PROP:Alrt,255} = UpKey
%Window{PROP:Alrt,255} = PgDnKey
%Window{PROP:Alrt,255} = PgUpKey
%Window{PROP:Alrt,255} = EndKey
%Window{PROP:Alrt,255} = HomeKey
%Window{PROP:Alrt,255} = CtrlEnd
%Window{PROP:Alrt,255} = CtrlHome
%Window{PROP:Alrt,255} = CtrlPgDn
%Window{PROP:Alrt,255} = CtrlPgUp
#IF(%ShouldISortTheQueue)
SORT(%QueueName,+%QueueSortField)
#ENDIF
#ENDAT
#AT(%WindowEventHandling,'AlertKey')
IF FOCUS() = %ListBoxUseVariable
  IF KeyCode() <> BSKey
    IF KeyCode() >= Key0 AND KeyCode() <= ZKey
      AVR:QLocator = CLIP(LEFT(AVR:QLocator)) & CHR(KeyCode())
    ELSIF KeyCode() >= KeyPad0 AND KeyCode() <= KeyPad9
      AVR:QLocator = CLIP(LEFT(AVR:QLocator)) & CHR(KeyCode()-48)
    ELSE
      AVR:QLocator = ''
    END
  ELSIF KeyCode() = BSKey
    IF LEN(CLIP(AVR:QLocator)) > 0
      AVR:QLocator = SUB(CLIP(AVR:QLocator),1,LEN(CLIP(AVR:QLocator))-1)
      IF LEN(CLIP(AVR:QLocator)) = 0
        GET(%QueueName,1)
        %ListBoxUseVariable{PROP:SelStart} = 1
        POST(EVENT:NewSelection,%ListBoxUseVariable)
      END
    END
  END
  !Find an entry!
  IF CLIP(AVR:QLocator) <> ''
    %QueueSortField = CLIP(AVR:QLocator)
    AVR:Position = POSITION(%QueueName)
    IF AVR:Position > RECORDS(%QueueName)
      AVR:Position = RECORDS(%QueueName)
    END
    GET(%QueueName,AVR:Position)
    %ListBoxUseVariable{PROP:SelStart} = AVR:Position
    POST(EVENT:NewSelection,%ListBoxUseVariable)
  END
END
#ENDAT
#AT(%WindowEventHandling,'PreAlertKey')
IF FOCUS() <> %ListBoxUseVariable
  CYCLE
ELSE !Mousedown etc
  IF (KeyCode() < Key0 OR KeyCode() > ZKey) AND (KeyCode() < KeyPad0 OR KeyCode() > KeyPad9)
    CYCLE
  END
END
#ENDAT
